//	AksPro - ObjectARX module for AutoCAD 2005
//	Copyright (C) 2005 Wiebe Leonid, All Rights Reserved.
//
//	This software is provided 'as-is', without any express or implied
//	warranty.  In no event will the authors be held liable for any
//	damages arising from the use of this software.
//
//	Permission is granted to anyone to use this software for any purpose,
//	including commercial applications, and to alter it and redistribute it
//	freely, subject to the following restrictions:
//
//	1.	The origin of this software must not be misrepresented; you must
//		not claim that you wrote the original software. If you use this
//		software in a product, an acknowledgment in the product
//		documentation would be appreciated but is not required.
//	2.	Altered source versions must be plainly marked as such, and must
//		not be misrepresented as being the original software.
//	3.	This notice may not be removed or altered from any source
//		distribution.

//	AksPro -  ObjectARX  AutoCAD 2005
//	  2005,  
//
//	     ; 
//	   /     
//	     GNU   , 
//	      ; 
//	  2   (  )    .
//
//	   ,    , 
//	        ; 
//	    ,  
//	       . 
//	      GNU.
//
//	        GNU 
//	   ;    ,      
//	(Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA).

#include "stdafx.h"
#include "SetDlg.h"
#include "Windowsx.h"

extern ACHAR* vers;

extern bool bDragMode;

extern PREFS prefCurSet;
extern PREFS prefFileSet;


IMPLEMENT_DYNAMIC(SetDlg, CDialog)

/////////////////////////////////////
SetDlg::SetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SetDlg::IDD, pParent)
	, m_dX(prefFileSet.dAngleX)
	, m_dY(prefFileSet.dAngleY)
	, m_dZ(prefFileSet.dAngleZ)
	, m_iFX(prefFileSet.dFactorX*100)
	, m_iFY(prefFileSet.dFactorY*100)
	, m_iFZ(prefFileSet.dFactorZ*100)
	, m_iMirror(prefFileSet.iMirror)
	, m_SelElems(prefFileSet.iSelElems)
	, m_SegQty(prefFileSet.iSegQty)
	, m_iNewDoc(prefFileSet.iCreateNewDoc)
{


}

////////////////////
SetDlg::~SetDlg()
{
}

////////////////////////////////
BOOL SetDlg::Create( CWnd* pParent )
{


    return CDialog::Create(SetDlg::IDD, pParent);
}

////////////////////////////////
BOOL SetDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ACHAR str[50] = _T("AksPro v");
	_tcscat(str, vers);

	this->SetWindowText(str);


	m_cmbAksType.Clear();
//	m_cmbAksType.AddString(_T("1.1  "));
//	m_cmbAksType.AddString(_T("1.2  "));
//	m_cmbAksType.AddString(_T("2.1   "));
//	m_cmbAksType.AddString(_T("2.2   "));
//	m_cmbAksType.AddString(_T("2.3   "));
//	m_cmbAksType.AddString(_T("  "));
  ComboBox_AddString(m_cmbAksType, _T("1.1  "));
  ComboBox_AddString(m_cmbAksType, _T("1.2  "));
  ComboBox_AddString(m_cmbAksType, _T("2.1   "));
  ComboBox_AddString(m_cmbAksType, _T("2.2   "));
  ComboBox_AddString(m_cmbAksType, _T("2.3   "));
  ComboBox_AddString(m_cmbAksType, _T("  "));

	m_cmbAksType.SetCurSel(prefFileSet.iAksType);


	m_SliderX.SetPageSize(10);
	m_SliderY.SetPageSize(10);
	m_SliderZ.SetPageSize(10);

	m_SliderX.SetRange(0, 200);
	m_SliderY.SetRange(0, 200);
	m_SliderZ.SetRange(0, 200);

	m_SliderX.SetTicFreq(100);
	m_SliderY.SetTicFreq(100);
	m_SliderZ.SetTicFreq(100);

	setEnabled();




	UpdateData();

	return TRUE;
}

//////////////////////////////////////////
void SetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO2, m_cmbAksType);
	DDX_Text(pDX, IDC_EDIT2, m_dX);
	DDV_MinMaxDouble(pDX, m_dX, 0, 360);
	DDX_Text(pDX, IDC_EDIT3, m_dY);
	DDV_MinMaxDouble(pDX, m_dY, 0, 360);
	DDX_Text(pDX, IDC_EDIT4, m_dZ);
	DDV_MinMaxDouble(pDX, m_dZ, 0, 360);
	DDX_Slider(pDX, IDC_SLIDER3, m_iFX);
	DDV_MinMaxDouble(pDX, m_iFX, 0, 200);
	DDX_Slider(pDX, IDC_SLIDER2, m_iFY);
	DDV_MinMaxDouble(pDX, m_iFY, 0, 200);
	DDX_Slider(pDX, IDC_SLIDER1, m_iFZ);
	DDV_MinMaxDouble(pDX, m_iFZ, 0, 200);
	DDX_Control(pDX, IDC_SLIDER3, m_SliderX);
	DDX_Control(pDX, IDC_SLIDER2, m_SliderY);
	DDX_Control(pDX, IDC_SLIDER1, m_SliderZ);
	DDX_Check(pDX, IDC_CHECK1, m_iMirror);
	DDX_Check(pDX, IDC_CHECK2, m_SelElems);
	DDX_Text(pDX, IDC_EDIT1, m_SegQty);
	DDX_Control(pDX, IDC_EDIT2, m_AxisX);
	DDX_Control(pDX, IDC_EDIT3, m_AxisY);
	DDX_Control(pDX, IDC_EDIT4, m_AxisZ);
	DDX_Control(pDX, IDC_SPIN2, m_SpinX);
	DDX_Control(pDX, IDC_SPIN3, m_SpinY);
	DDX_Control(pDX, IDC_SPIN4, m_SpinZ);
	DDX_Check(pDX, IDC_CHECK3, m_iNewDoc);
	DDX_Control(pDX, IDC_CHECK3, m_chkCrDoc);
}


BEGIN_MESSAGE_MAP(SetDlg, CDialog)
	ON_MESSAGE( WM_ACAD_KEEPFOCUS, onAcadKeepFocus )
	ON_WM_CREATE()
	ON_WM_HSCROLL()
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN2, OnDeltaposSpin2)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN3, OnDeltaposSpin3)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN4, OnDeltaposSpin4)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnCbnSelchangeCombo2)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_ACTIVATE()
	ON_EN_KILLFOCUS(IDC_EDIT2, OnEnKillfocusEdit2)
	ON_EN_KILLFOCUS(IDC_EDIT3, OnEnKillfocusEdit3)
	ON_EN_KILLFOCUS(IDC_EDIT4, OnEnKillfocusEdit4)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN5, OnDeltaposSpin5)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN6, OnDeltaposSpin6)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN7, OnDeltaposSpin7)
END_MESSAGE_MAP()

//////////////////////////////////////
LRESULT SetDlg::onAcadKeepFocus( WPARAM, LPARAM )
{
    return TRUE;
}


// SetDlg message handlers

////////////////////////////////
int SetDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;


	return 0;
}

///////////////////////////////////////////
void SetDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	UpdateData();
	ACHAR val[10];
	_stprintf(val, _T("%.2f"), m_iFX/100.);
	SetDlgItemText(IDC_STATIC1, val);
	_stprintf(val, _T("%.2f"), m_iFY/100.);
	SetDlgItemText(IDC_STATIC2, val);
	_stprintf(val, _T("%.2f"), m_iFZ/100.);
	SetDlgItemText(IDC_STATIC3, val);
}





void SetDlg::OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	int val = GetDlgItemInt(IDC_EDIT1);
	val+=-pNMUpDown->iDelta;
	if (val < 4) val = 4;
	SetDlgItemInt(IDC_EDIT1, val);
	*pResult = 0;
}

void SetDlg::OnDeltaposSpin2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setAngle(m_dX + -pNMUpDown->iDelta, IDC_EDIT2);
	*pResult = 0;
}

void SetDlg::OnDeltaposSpin3(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setAngle(m_dY + -pNMUpDown->iDelta, IDC_EDIT3);
	*pResult = 0;
}

void SetDlg::OnDeltaposSpin4(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setAngle(m_dZ + -pNMUpDown->iDelta, IDC_EDIT4);
	*pResult = 0;
}

void SetDlg::setEnabled(void)
{
	double dX;
	double dY;
	double dZ;
	ACHAR valx[10];
	ACHAR valy[10];
	ACHAR valz[10];

	int fx;
	int fy;
	int fz;


	int i = m_cmbAksType.GetCurSel();
	if (i == 0)
	{
		_stprintf(valx, _T("%.2f"), 210.);
		_stprintf(valy, _T("%.2f"), 330.);
		_stprintf(valz, _T("%.2f"), 90.);
		fx = 100; fy = 100; fz = 100;
	}
	else if (i == 1)
	{
		_stprintf(valx, _T("%.2f"), 187.17);
		_stprintf(valy, _T("%.2f"), 318.58);
		_stprintf(valz, _T("%.2f"), 90.);
		fx = 94; fy = 47; fz = 94;
	}
	else if (i == 2)
	{
		_stprintf(valx, _T("%.2f"), 180.);
		_stprintf(valy, _T("%.2f"), 315.);
		_stprintf(valz, _T("%.2f"), 90.);
		fx = 100; fy = 100; fz = 100;
	}
	else if (i == 3)
	{
		_stprintf(valx, _T("%.2f"), 240.);
		_stprintf(valy, _T("%.2f"), 330.);
		_stprintf(valz, _T("%.2f"), 90.);
		fx = 100; fy = 100; fz = 100;
	}
	else if (i == 4)
	{
		_stprintf(valx, _T("%.2f"), 180.);
		_stprintf(valy, _T("%.2f"), 315.);
		_stprintf(valz, _T("%.2f"), 90.);
		fx = 100; fy = 50; fz = 100;
	}

	if (i == 5)
	{
		_stprintf(valx, _T("%.2f"), prefFileSet.dAngleX);
		m_AxisX.SetWindowText(valx);
		_stprintf(valy, _T("%.2f"), prefFileSet.dAngleY);
		m_AxisY.SetWindowText(valy);
		_stprintf(valz, _T("%.2f"), prefFileSet.dAngleZ);
		m_AxisZ.SetWindowText(valz);

		m_SliderX.SetPos((int)(prefFileSet.dFactorX*100.));
		m_SliderY.SetPos((int)(prefFileSet.dFactorY*100.));
		m_SliderZ.SetPos((int)(prefFileSet.dFactorZ*100.));

		ACHAR val[10];
		_stprintf(val, _T("%.2f"), prefFileSet.dFactorX);
		SetDlgItemText(IDC_STATIC1, val);
		_stprintf(val, _T("%.2f"), prefFileSet.dFactorY);
		SetDlgItemText(IDC_STATIC2, val);
		_stprintf(val, _T("%.2f"), prefFileSet.dFactorZ);
		SetDlgItemText(IDC_STATIC3, val);

		m_AxisX.EnableWindow(TRUE);
		m_AxisY.EnableWindow(TRUE);
		m_AxisZ.EnableWindow(TRUE);
		m_SpinX.EnableWindow(TRUE);
		m_SpinY.EnableWindow(TRUE);
		m_SpinZ.EnableWindow(TRUE);
		m_SliderX.EnableWindow(TRUE);
		m_SliderY.EnableWindow(TRUE);
		m_SliderZ.EnableWindow(TRUE);
	}
	else
	{
		m_AxisX.SetWindowText(valx);
		m_AxisY.SetWindowText(valy);
		m_AxisZ.SetWindowText(valz);

		m_SliderX.SetPos(fx);
		m_SliderY.SetPos(fy);
		m_SliderZ.SetPos(fz);

		ACHAR val[10];
		_stprintf(val, _T("%.2f"), fx/100.);
		SetDlgItemText(IDC_STATIC1, val);
		_stprintf(val, _T("%.2f"), fy/100.);
		SetDlgItemText(IDC_STATIC2, val);
		_stprintf(val, _T("%.2f"), fz/100.);
		SetDlgItemText(IDC_STATIC3, val);

		m_AxisX.EnableWindow(FALSE);
		m_AxisY.EnableWindow(FALSE);
		m_AxisZ.EnableWindow(FALSE);
		m_SliderX.EnableWindow(FALSE);
		m_SliderY.EnableWindow(FALSE);
		m_SliderZ.EnableWindow(FALSE);
		m_SpinX.EnableWindow(FALSE);
		m_SpinY.EnableWindow(FALSE);
		m_SpinZ.EnableWindow(FALSE);
	}


}

void SetDlg::OnCbnSelchangeCombo2()
{
	setEnabled();
}

void SetDlg::OnBnClickedOk()
{
	UpdateData();

	prefFileSet.iAksType = m_cmbAksType.GetCurSel();
	prefFileSet.iSegQty = m_SegQty;
	prefFileSet.iSelElems = m_SelElems;
	prefFileSet.iMirror = m_iMirror;
	prefFileSet.iCreateNewDoc = m_iNewDoc;

	if (prefFileSet.iAksType > 4)
	{
		prefFileSet.dAngleX = m_dX;
		prefFileSet.dAngleY = m_dY;
		prefFileSet.dAngleZ = m_dZ;
		prefFileSet.dFactorX = m_iFX/100.;
		prefFileSet.dFactorY = m_iFY/100.;
		prefFileSet.dFactorZ = m_iFZ/100.;
	}

	syncCurSetToFileSet();

	saveSettings();
	
	OnOK();
}

void SetDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
}

void SetDlg::OnEnKillfocusEdit2()
{
	UpdateData();
	setAngle(m_dX, IDC_EDIT2);
}
void SetDlg::OnEnKillfocusEdit3()
{
	UpdateData();
	setAngle(m_dY, IDC_EDIT3);
}

void SetDlg::OnEnKillfocusEdit4()
{
	UpdateData();
	setAngle(m_dZ, IDC_EDIT4);
}

void SetDlg::setAngle(double dval, int ident)
{
	if (dval < 0) dval = 360.;
	if (dval > 360) dval = 0.;
	ACHAR sval[50];
	_stprintf(sval, _T("%.2f"), dval);
	SetDlgItemText(ident, sval);
}

void SetDlg::setFactor(int ival, int ident)
{
	if (ival < 0) ival = 0;
	wchar_t sval[50];
	_stprintf(sval, _T("%.2f"), ival/100.);
	SetDlgItemText(ident, sval);
	if (ident == IDC_STATIC1) m_SliderX.SetPos(ival);
	if (ident == IDC_STATIC2) m_SliderY.SetPos(ival);
	if (ident == IDC_STATIC3) m_SliderZ.SetPos(ival);
}


void SetDlg::OnBnClickedButton1()
{
	printVers();
}

void SetDlg::OnDeltaposSpin5(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setFactor(m_iFX + -pNMUpDown->iDelta, IDC_STATIC1);
	*pResult = 0;
}

void SetDlg::OnDeltaposSpin6(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setFactor(m_iFY + -pNMUpDown->iDelta, IDC_STATIC2);
	*pResult = 0;
}

void SetDlg::OnDeltaposSpin7(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	UpdateData();
	setFactor(m_iFZ + -pNMUpDown->iDelta, IDC_STATIC3);
	*pResult = 0;
}

void SetDlg::syncToSettings(void)
{
	m_cmbAksType.SetCurSel(prefFileSet.iAksType);


	m_iNewDoc = prefFileSet.iCreateNewDoc;
	m_iMirror = prefFileSet.iMirror;
	m_SelElems = prefFileSet.iSelElems;
	m_SegQty = prefFileSet.iSegQty;

	UpdateData(FALSE);

	if (checkSDI(false))
	{
		m_chkCrDoc.SetCheck(0);
		m_chkCrDoc.EnableWindow(FALSE);
	}
	else
	{
		m_chkCrDoc.EnableWindow();
	}

	setEnabled();
}
